// CSS animations

@use 'fun';

@mixin animation($value) {
  animation: $value;
}

// none <keyframes-name>
@mixin animation-name($value) {
  animation-name: $value;
}

// <time>?
@mixin animation-delay($value) {
  animation-delay: $value;
}

// <time>?
@mixin animation-duration($value) {
  animation-duration: $value;
}

// replace add accumulate
@mixin animation-composition($value) {
  animation-composition: $value;
}

// normal reverse alternate alternate-reverse
@mixin animation-direction($value) {
  animation-direction: $value;
}

// none forwards backwards both
@mixin animation-fill-mode($value) {
  animation-fill-mode: $value;
}

// running paused
@mixin animation-play-state($value) {
  animation-play-state: $value;
}

// https://drafts.csswg.org/css-animations/#propdef-animation-timing-function
// ease ease-in ease-out ease-in-out linear step-start step-end
// cubic-bezier() linear() steps()
// https://www.w3.org/TR/css-easing-1/#cubic-bezier-easing-functions
// ease: cubic-bezier(0.25, 0.1, 0.25, 1)
// ease-in: cubic-bezier(0.42, 0, 1, 1)
// ease-out: cubic-bezier(0, 0, 0.58, 1)
// ease-in-out: cubic-bezier(0.42, 0, 0.58, 1)
// https://www.w3.org/TR/css-easing-1/#the-linear-easing-function
// linear: linear(0, 1)
// https://www.w3.org/TR/css-easing-1/#step-easing-functions
// step-start: steps(1, start)
// step-end: steps(1, end)
@mixin animation-timing-function($value) {
  animation-timing-function: $value;
}

// propertyName [duration [timingFunction] [delay]][,]
@mixin transition($value) {
  @include fun.prefix-add-moz('transition', $value);
}

// <time>?
@mixin transition-duration($value) {
  @include fun.prefix-add-moz('transition-duration', $value);
}

// none all
// propertyName
@mixin transition-property($value) {
  @include fun.prefix-add-moz('transition-property', $value);
}

// <time>?
@mixin transition-delay($value) {
  @include fun.prefix-add-moz('transition-delay', $value);
}

// https://developer.mozilla.org/en-US/docs/Web/CSS/transition-timing-function
// ease ease-in ease-out ease-in-out linear step-start step-end
// cubic-bezier() linear() steps()
// https://drafts.csswg.org/css-easing-2/#cubic-bezier-easing-functions
// ease: cubic-bezier(0.25, 0.1, 0.25, 1)
// ease-in: cubic-bezier(0.42, 0, 1, 1)
// ease-out: cubic-bezier(0, 0, 0.58, 1)
// ease-in-out: cubic-bezier(0.42, 0, 0.58, 1)
// https://drafts.csswg.org/css-easing-2/#the-linear-easing-keyword
// linear: linear(0, 1) or cubic-bezier(0, 0, 1, 1)
// https://drafts.csswg.org/css-easing-2/#step-easing-functions
// step-start: steps(1, start)
// step-end: steps(1, end)
@mixin transition-timing-function($value) {
  @include fun.prefix-add-moz('transition-timing-function', $value);
}

// matrix() translate() translateX() translateY()
// scale() scaleX() scaleY() rotate() matrix3d()
// skew() skewX() skewY() translate3d() translateZ()
// scale3d() scaleZ() rotate3d() rotateX() rotateY()
// rotateY() perspective()
@mixin transform($value) {
  transform: $value;
}

@mixin scale($value) {
  @include transform(scale($value));
}

@mixin rotate($value) {
  @include transform(rotate($value));
}

@mixin skew($value) {
  @include transform(skew($value));
}

@mixin translate($value) {
  @include transform(translate($value));
}

@mixin translateX($value) {
  @include transform(translateX($value));
}

@mixin translateY($value) {
  @include transform(translateY($value));
}

// keyword: top bottom left right center
// keyword [keyword [z-offset]]
// x-offset y-offset [z-offset]
@mixin transform-origin($value) {
  transform-origin: $value;
}

@mixin transform-none() {
  @include transform(none);
}

@mixin box-shadow($value) {
  box-shadow: $value;
}
